/// <reference path="../../reference/cristalix.d.ts" />
import { ItemElement, RectangleElement, TextElement } from './elements';
import { runningTasks } from "./fast-gui";
export var CENTER = { x: 0.5, y: 0.5 };
export var LEFT = { x: 0, y: 0.5 };
export var RIGHT = { x: 1, y: 0.5 };
export var TOP = { x: 0.5, y: 0 };
export var BOTTOM = { x: 0.5, y: 1 };
export var TOP_RIGHT = { x: 1, y: 0 };
export var TOP_LEFT = { x: 0, y: 0 };
export var BOTTOM_RIGHT = { x: 1, y: 1 };
export var BOTTOM_LEFT = { x: 0, y: 1 };
export function schedule(delay, action) {
    runningTasks.push({
        time: System.currentTimeMillis() + delay,
        action: action
    });
}
export function rect(data) {
    var element = new RectangleElement(data);
    element.cleanMatrices();
    return element;
}
export function text(data) {
    var element = new TextElement(data);
    element.cleanMatrices();
    return element;
}
export function item(data) {
    var element = new ItemElement(data);
    element.cleanMatrices();
    return element;
}
