/// <reference path="../reference/cristalix.d.ts" />
export function long(v) {
    return new NBTTagLong(v);
}
export function double(v) {
    return new NBTTagDouble(v);
}
export function int(v) {
    return new NBTTagInt(v);
}
export function float(v) {
    return new NBTTagFloat(v);
}
export function short(v) {
    return new NBTTagShort(v);
}
export function byte(v) {
    return new NBTTagByte(v);
}
export function boolean(v) {
    return new NBTTagByte(v ? 1 : 0);
}
export function string(v) {
    return new NBTTagString(v);
}
export function bytes(v) {
    return new NBTTagByteArray(v);
}
export function ints(v) {
    return new NBTTagIntArray(v);
}
export function longs(v) {
    return new NBTTagLongArray(v);
}
export function strings(v) {
    return new NBTTagList(v.map(string));
}
export function list(values) {
    return new NBTTagList(values);
}
export function number(v) {
    return (v >= -128 && v <= 127) ? new NBTTagByte(v)
        : (v >= -32768 && v <= 32767) ? new NBTTagShort(v)
            : (v >= 0x80000000 && v <= 0x7fffffff) ? new NBTTagInt(v)
                : new NBTTagLong(v);
}
export function nbt(data) {
    var result = new NBTTagCompound();
    for (var key in data) {
        result.setTag(key, data[key]);
    }
    return result;
}
